// Creates namespaces to be used for scoping variables and classes so that they are not global.
Ext.namespace('GO.testmodule');

/*
 * This is the constructor of our MainPanel
 */
GO.testmodule.MainPanel = function(config){

	if(!config)
	{
		config = {};
	} 

	config.html='Hello World';
	
	var centerPanel = new GO.testmodule.PresidentsGrid({
		region:'center',
		title:GO.lang.menu,
		autoScroll:true,		
		width:250,
		split:true
	});
	
	centerPanel.on('rowdblclick', function(grid, rowIndex)
	{	
		this.presidentDialog = new GO.testmodule.PresidentDialog();
	  	this.presidentDialog.on('save', function(){
			grid.store.reload();
		}, this);
		
		var record = grid.getStore().getAt(rowIndex);		
		this.presidentDialog.show(record.data.id);
			
	}, this);
	
	var northPanel = new Ext.Panel({
		region: 'north',
		baseCls:'x-plain',
		split: true,
		resizable:false,
		tbar: new Ext.Toolbar({		
			cls:'go-head-tb',
			items: [{
				iconCls: 'btn-add',							
				text: GO.lang['cmdAdd'],
				cls: 'x-btn-text-icon',
				handler: function(){
					this.presidentDialog = new GO.testmodule.PresidentDialog();
					this.presidentDialog.on('save', function(){
						centerPanel.getStore().reload();
					}, this);
					this.presidentDialog.show();
				},
				scope: this
			},{
				iconCls: 'btn-delete',
				text: GO.lang['cmdDelete'],
				cls: 'x-btn-text-icon',
				handler: function(){
					centerPanel.deleteSelected();
				},
				scope: this
			}]
		})
	});
		
	config.items=[
		northPanel,
		centerPanel
	];
	
	config.layout='border';
	
	
	/*
	 * Explicitly call the superclass constructor
	 */
 	GO.testmodule.MainPanel.superclass.constructor.call(this, config);

}

/*
 * Extend the base class
 */
Ext.extend(GO.testmodule.MainPanel, Ext.Panel,{

});

/*
 * This will add the module to the main tabpanel filled with all the modules
 */
GO.moduleManager.addModule('testmodule', GO.testmodule.MainPanel, {
	title : 'Test Module',
	iconCls : 'go-module-icon-testmodule'
});


