<?php

require_once('../../Group-Office.php');

//Authenticate the user
$GO_SECURITY->json_authenticate('testmodule');

//Require the module class
require_once ($GO_MODULES->modules['testmodule']['class_path'].'presidents.class.inc.php');
$presidents = new presidents();

$task=isset($_REQUEST['task']) ? $_REQUEST['task'] : '';

try{

	switch($task)
	{
		
		/* {TASKSWITCH} */
		
		case 'president':	
			/*
			 * This task is executed when we need to edit a president
			 * with president_id = $_REQUEST['president_id']
			 */
			$president = $presidents->get_president($_REQUEST['president_id']);
			$president['income']=Number::format($president['income']);
			$response['data']=$president;
			$response['success']=true;	
			break;
				
		case 'presidents':
			/*
			 * This task is executed when we need to delete 1 or more president(s) or
			 * whenever we want to retrieve the data of all the presidents
			 * (for example: to list them in our GridPanel)
			 */
			if(isset($_POST['delete_keys']))
			/*
			 * $_POST['delete_keys'] holds the president_id(s) of 
			 * all the president(s) we need to delete 1 by 1  
			 */
			{
				try{
					$response['deleteSuccess']=true;
					$delete_presidents = json_decode($_POST['delete_keys']);

					foreach($delete_presidents as $president_id)
					{
						$presidents->delete_president($president_id);
					}
				}catch(Exception $e)
				{
					$response['deleteSuccess']=false;
					$response['deleteFeedback']=$e->getMessage();
				}
			}
							
			$sort = isset($_REQUEST['sort']) ? $_REQUEST['sort'] : 'id';
			$dir = isset($_REQUEST['dir']) ? $_REQUEST['dir'] : 'ASC';
			$start = isset($_REQUEST['start']) ? $_REQUEST['start'] : '0';
			$limit = isset($_REQUEST['limit']) ? $_REQUEST['limit'] : '0';
			$query = isset($_REQUEST['query']) ? '%'.$_REQUEST['query'].'%' : '';
		
			$presidents->get_presidents($sort, $dir, $start, $limit);
			$response['results']=array();
			while($presidents->next_record())
			{
				$president = $presidents->record;				
				$president['tookoffice']=Date::format($president['tookoffice'],false);
				$president['leftoffice']=Date::format($president['leftoffice'],false);							
				$response['results'][] = $president;
			}
			$response['total'] = $presidents->found_rows();
			break;
			
		case 'parties':
			/*
			 * This task is executed when the combobox of our Dialog is activated
			 * it task returns a list of all the available parties
			 */
			$response['total'] = $presidents->get_parties();
			$response['results']=array();
			while($presidents->next_record())
			{
				$parties = $presidents->record;			
				$response['results'][] = $parties;
			}				
			break;

	}
}catch(Exception $e)
{
	$response['feedback']=$e->getMessage();
	$response['success']=false;
}

// return $response to the client in an JSON encoded string 
echo json_encode($response);
